package cz.fidentis.analyst.gui.project.faceinfo;

import cz.fidentis.analyst.gui.task.ControlPanel;
import cz.fidentis.analyst.gui.elements.FaceInfoPanel;
import java.awt.event.ActionListener;
import javax.swing.ImageIcon;

/**
 *
 * @author Matej Kovar
 */
public class FaceInfoControlPanel extends ControlPanel {
    
    /*
     * Mandatory design elements
     */
    public static final String NAME = "Face Info";
    public static final String ICON = "head28x28.png";
    
    /*
     * External actions
     */
    public static final String ACTION_LOAD_GEOMETRY_INFO = "Load geometry info";
    
    /**
     * Constructor.
     * @param action Action listener
     */
    public FaceInfoControlPanel(ActionListener action) {
        super(action);
        
        this.setName(NAME);
        
        initComponents();
        
        loadInfoButton.addActionListener(createListener(action, ACTION_LOAD_GEOMETRY_INFO));
        //loadInfoButton.setToolTipText("Loads face geometry info from file in specified file path");
    }
    
    public FaceInfoPanel getInfoPanel() {
        return this.faceInfoPanel1;
    }
    
    @Override
    public ImageIcon getIcon() {
        return getStaticIcon();
    }
    
    /**
     * Static implementation of the {@link #getIcon()} method.
     * 
     * @return Control panel icon
     */
    public static ImageIcon getStaticIcon() {
        return new ImageIcon(FaceInfoPanel.class.getClassLoader().getResource("/" + ICON));
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        loadInfoButton = new javax.swing.JButton();
        faceInfoPanel1 = new cz.fidentis.analyst.gui.elements.FaceInfoPanel();

        loadInfoButton.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        org.openide.awt.Mnemonics.setLocalizedText(loadInfoButton, org.openide.util.NbBundle.getMessage(FaceInfoControlPanel.class, "FaceInfoControlPanel.loadInfoButton.text")); // NOI18N
        loadInfoButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadInfoButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(faceInfoPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(loadInfoButton))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(faceInfoPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(loadInfoButton)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void loadInfoButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadInfoButtonActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_loadInfoButtonActionPerformed
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private cz.fidentis.analyst.gui.elements.FaceInfoPanel faceInfoPanel1;
    private javax.swing.JButton loadInfoButton;
    // End of variables declaration//GEN-END:variables

}
