package cz.fidentis.analyst.gui.task.faceinfo;

import cz.fidentis.analyst.canvas.Canvas;
import cz.fidentis.analyst.data.face.HumanFaceEvent;
import cz.fidentis.analyst.data.face.HumanFaceListener;
import cz.fidentis.analyst.gui.task.ControlPanelAction;
import cz.fidentis.analyst.project.FacesProxy;

import javax.swing.*;
import java.awt.event.ActionEvent;

/**
 * Action listener for face info.
 * 
 * @author Radek Oslejsek
 */
public class FaceOverviewAction extends ControlPanelAction<FaceOverviewPanel> implements HumanFaceListener {
    
/**
     * Constructor.
     * A new {@code DistancePanel} is instantiated and added to the {@code topControlPane}
     * 
     * @param canvas OpenGL canvas
     * @param faces Faces processed by current analytical task
     * @param topControlPane A top component when a new control panel is placed
     * @param faceIndex face index from the {@code faces}
     */
    public FaceOverviewAction(Canvas canvas, FacesProxy faces, JTabbedPane topControlPane, int faceIndex) {
        super(canvas, faces, topControlPane);
        setControlPanel(new FaceOverviewPanel(this, faces, faceIndex));
        setShowHideCode(
                () -> { // SHOW
                },
                () -> { // HIDE
                }
        );
    }

    @Override
    public void actionPerformed(ActionEvent ae) {
        final String action = ae.getActionCommand();
        switch (action) {
            default:
                // to nothing
        }
        renderScene();
    }
    
    @Override
    public void acceptEvent(HumanFaceEvent event) {
    }    
}
