package cz.fidentis.analyst.gui.task.interactivemask;

import cz.fidentis.analyst.gui.task.ControlPanel;
import cz.fidentis.analyst.gui.task.featurepoints.FeaturePointsPanel;
import cz.fidentis.analyst.data.shapes.SurfaceMask;

import java.awt.event.ActionListener;
import javax.swing.ImageIcon;

/**
 *
 * @author Mario Chromik
 */
public class InteractiveMaskPanel extends ControlPanel {
    public static final String ICON = "fps28x28.png";
    public static final String NAME = "Interactive Mask";
    
    public static final String ACTION_DRAW = "draw interactive mask";
    public static final String ACTION_EDIT = "edit interactive mask";
    public static final String ACTION_VIEW = "view interactive mask";
    
    
    /**
     * Creates new form InteractiveMaskPanel
     */
    public InteractiveMaskPanel(ActionListener action) {
        super(action);
        setName(NAME);
        initComponents();
        view.setSelected(true);
        draw.addActionListener(createListener(action, ACTION_DRAW));
        edit.addActionListener(createListener(action, ACTION_EDIT));
        view.addActionListener(createListener(action, ACTION_VIEW));
    }
    
    public void setInteractiveMasks(int slot, SurfaceMask surfaceMask) {
        
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        buttonGroup2 = new javax.swing.ButtonGroup();
        draw = new javax.swing.JRadioButton();
        edit = new javax.swing.JRadioButton();
        view = new javax.swing.JRadioButton();
        jLabel9 = new javax.swing.JLabel();

        buttonGroup1.add(draw);
        draw.setSelected(true);
        org.openide.awt.Mnemonics.setLocalizedText(draw, org.openide.util.NbBundle.getMessage(InteractiveMaskPanel.class, "InteractiveMaskPanel.draw.text")); // NOI18N
        draw.setActionCommand(org.openide.util.NbBundle.getMessage(InteractiveMaskPanel.class, "InteractiveMaskPanel.draw.actionCommand")); // NOI18N

        buttonGroup1.add(edit);
        org.openide.awt.Mnemonics.setLocalizedText(edit, org.openide.util.NbBundle.getMessage(InteractiveMaskPanel.class, "InteractiveMaskPanel.edit.text")); // NOI18N
        edit.setActionCommand(org.openide.util.NbBundle.getMessage(InteractiveMaskPanel.class, "InteractiveMaskPanel.edit.actionCommand")); // NOI18N

        buttonGroup1.add(view);
        org.openide.awt.Mnemonics.setLocalizedText(view, org.openide.util.NbBundle.getMessage(InteractiveMaskPanel.class, "InteractiveMaskPanel.view.text")); // NOI18N

        jLabel9.setForeground(new java.awt.Color(255, 153, 0));
        org.openide.awt.Mnemonics.setLocalizedText(jLabel9, org.openide.util.NbBundle.getMessage(InteractiveMaskPanel.class, "InteractiveMaskPanel.jLabel9.text")); // NOI18N
        jLabel9.setToolTipText(org.openide.util.NbBundle.getMessage(InteractiveMaskPanel.class, "InteractiveMaskPanel.jLabel9.toolTipText")); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel9, javax.swing.GroupLayout.DEFAULT_SIZE, 396, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(draw)
                            .addComponent(edit)
                            .addComponent(view))
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(draw)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(edit)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(view)
                .addGap(18, 18, 18)
                .addComponent(jLabel9)
                .addContainerGap(183, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    @Override
    public ImageIcon getIcon() {
        return getStaticIcon();
    }

    /**
     * Static implementation of the {@link #getIcon()} method.
     *
     * @return Control panel icon
     */
    public static ImageIcon getStaticIcon() {
        return new ImageIcon(FeaturePointsPanel.class.getClassLoader().getResource("/" + ICON));
    }
 
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.ButtonGroup buttonGroup2;
    private static javax.swing.JRadioButton draw;
    private static javax.swing.JRadioButton edit;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JRadioButton view;
    // End of variables declaration//GEN-END:variables
}
